#!/usr/bin/perl -w
# -*- mode: cperl; coding: utf-8-unix; indent-tabs-mode: t -*-
# $Id: $
#
# 毎日実行する処理
#
# 0 0 * * * /path/to/local/cron_d.pl
#
use FindBin;
use lib "$FindBin::Bin/plugins", "$FindBin::Bin/lib";
use strict;
use Cozy::DateTime;
my $SCRIPT = "$FindBin::Bin/manage.pl";
my @ARGS =
(
 # 無効にする処理は、'name=から始まる行頭に#を付けて下さい。

 # 不要データの削除
 # * 有効期限切れのセッションファイル(local/sid以下)を削除します。
 # * 有効期限切れの一時ファイル(local/tmp以下)を削除します。
 # * 有効期限切れの買い物かごの商品(catテーブル内)を削除します。
 # * 有効期限切れの配信済メルマガ(dmlテーブル内)を削除します。
 # * 有効期限切れのログ(logテーブル内)を削除します。
 # 各有効期限はlocal/plugin/00config.plで設定して下さい。
 'name=sysmgr pmd=clean',

 # 人気ショップの集計
 # * 過去数日分の決済支払金額をショップ別に集計します。
 # * 更新されたデータは、モール・ショップトップの人気ショップ一覧に反映されます。
 'name=odrmgr pmd=bscore days=90',

 # 人気商品の集計
 # * 過去数日分の商品の販売個数を商品別に集計します。
 # * 更新されたデータは、モール・ショップトップの人気商品一覧に反映されます。
 'name=odrmgr pmd=oscore days=90',

 # 全ショップのファイル更新
 # * local/static以下のファイルを更新します。
 # * 更新対象は「ショップ定期更新」を有効しているショップです。
 'name=webmgr pmd=build_all exec=1 force=1',

 # ポイントの発行
 # * 支払確認後、一定時間を経過した注文分のポイントを
 #   顧客の所有ポイントとして加算します。
 # * 入金確認後から加算されるまでの一定時間は
 #   local/plugin/00config.plで設定して下さい。
 'name=odrmgr pmd=paypoint exec=1',

 # 入荷通知メールの送信
 # * 在庫なしで買い物かごに入れた商品が入荷した場合に顧客に通知します。
 # * 通知対象は会員登録時に「お知らせ情報」を講読するに設定している会員です。
 'name=gdsmgr pmd=arrival exec=1',

 # 検索キーワードの更新
 # * 商品情報からキーワードを抽出して集計情報(gdszテーブル内)を更新します。
 # * 過去数日以内に更新された商品情報を対象に集計します。
 'name=gdsmgr pmd=replace_keywords days=1 sync=1 exec=1'
);

for my $args (@ARGS) {
	print Cozy::DateTime->new->datetime('[%04d/%02d/%02d %02d:%02d:%02d]'), "\n";
	print "$SCRIPT $args\n";
    !system "$SCRIPT $args" or die $?;
	print "\n";
}

__END__
# Copyright (C) 2000-2012 E-Shoppy Project developing team
# All rights reserved.
