#!/usr/bin/perl -w
# -*- mode: cperl; coding: utf-8-unix; indent-tabs-mode: t -*-
# $Id: $

use FindBin;
use lib "$FindBin::Bin/plugins", "$FindBin::Bin/lib";
use strict;
use Pod::Text;
use File::Find;
use Encode;
use Encode::Guess;
$| = 1;

my $DIR_DOCS = "$FindBin::Bin/docs";
my $DIR_PAGES = "$FindBin::Bin/lib/ESP/SMS/Pages";
my $DIR_BASE = $FindBin::Bin; $DIR_BASE =~ s/\/local$//;
my $parser = Pod::Text->new;
my @mod;
find(\&wanted, "$DIR_PAGES.pm", $DIR_PAGES);
copy($DIR_BASE.'/README', $DIR_BASE.'/README.SJIS', 'shiftjis', 'sjis-unix');

sub wanted {
	if (/\.pm$/) {
		my $module = $File::Find::name;
		$module =~ s|^.*lib/ESP/SMS/(.+)\.pm$|$1|;
		$module =~ s|/|-|g;
		$module = lc $module;
		my $in_file = $File::Find::name;
		my $out_file = "$DIR_DOCS/$module.txt";
		open my $in_fh, '<:encoding(utf-8)', $in_file or die "Can not create file : $in_file\n";
		open my $out_fh, '>:encoding(utf-8)', $out_file or die "Can not create file : $out_file\n";
		$parser->parse_from_filehandle($in_fh, $out_fh);
		close $out_fh;
		close $in_fh;
		print "Created: ./local/docs/$module.txt\n";
	}
}

sub copy {
	my ($file1, $file2, $encoding, $coding) = @_;
	my ($text, $fh);
	open $fh, '<', $file1 or die "Can not open: $file1\n";
	{
		local $/;
		$text = <$fh>;
		$text =~ s/ coding: [a-z0-9\-]+; / coding: $coding; /;
	}
	close $fh;
	my $guess = Encode::Guess::guess_encoding($text, qw/utf8 euc-jp shiftjis/);
	ref $guess or do { print "Created: $file2 (skip)\n"; return };
	my $enc = $guess->name;
	$text = Encode::decode($enc, $text);
	open $fh, '>', $file2 or die "Can not open: $file2\n";
	print $fh Encode::encode($encoding, $text);
	close $fh;
	print "Created: $file2 ($encoding)\n";
}

__END__
# Copyright (C) 2000-2012 E-Shoppy Project developing team
# All rights reserved.
