#!/usr/bin/perl -w
# -*- mode: cperl; coding: utf-8-unix; indent-tabs-mode: t -*-
# $Id: $

use File::Find;
use Encode;
use Encode::Guess;
$| = 1;

# このスクリプトは、skel以下のテンプレートをUTF-8に変換します。
# skel以下のテンプレートの文字コードは、PC画面/携帯画面とも
# UTF-8で保存する必要がありますので、もしShift_JISで保存した
# 場合は、このスクリプトを実行して下さい。
#
# 実行例: ./encode.pl skel
#
# (注意1) 実行前に1行目のPerlパスを設定して下さい。

my $dir = shift or die "Usage: $0 (skel directory)\n";

find({ wanted => \&wanted, no_chdir => 1 }, $dir);

sub wanted {
	my $file = $File::Find::name;
	my $bfile = $file.'~';
	return if -d $file || $file =~ /~$/;
	my ($text, $fh);
	open $fh, '<', $file or die "Can not open: $file\n";
	{
		local $/;
		$text = <$fh>;
	}
	close $fh;
	print $file;
	my $guess = Encode::Guess::guess_encoding($text, qw/utf8 euc-jp shiftjis/);
	ref $guess or do { print "\n"; return };
	my $enc = $guess->name;
	($enc eq 'shiftjis' || $enc eq 'euc-jp') or do { print " ($enc)\n"; return };
	$text = Encode::decode($enc, $text);
	unlink $bfile if -e $bfile;
	rename $file, $bfile or die "Can not rename: $file\n";
	open $fh, '>', $file or die "Can not open: $file\n";
	print $fh Encode::encode('utf8', $text);
	close $fh;
	print " encoded ($enc -> utf8)\n";
}

__END__
# Copyright (C) 2000-2012 E-Shoppy Project developing team
# All rights reserved.
