# -*- mode: cperl; coding: utf-8-unix; indent-tabs-mode: t -*-
# $Id: $

package ESP::SMS::DataHandler::File::Excel;

use strict;
our $VERSION = '0.02';

use Cozy::base qw(Cozy::DataHandler::File);
use Spreadsheet::ParseExcel;
use Spreadsheet::ParseExcel::FmtJapan;

# 初期化(ITERATORオブジェクト用)
sub init_iter {
	my $self = shift;
	return $self->croak("No defined parameter: 'file'")	unless defined $self->{file};
	my $excel = Spreadsheet::ParseExcel->new;
	my $format = Spreadsheet::ParseExcel::FmtJapan->new(Code => 'CP932');
	my $book = $excel->Parse($self->{file}, $format) or return $self->error("Can not open file : $!");
	my ($sheet) = @{$book->{Worksheet}}[0] or return $self->error("Not found Worksheet[0]");
	$sheet->{MaxRow} ||= $sheet->{MinRow};
	$self->{row} = $sheet->{MinRow};
	$self->{__sheet} = $sheet;
	return 1;
}

# 次取得(ITERATORオブジェクト用)
sub next_iter {
	my $self = shift;
	my $sheet = $self->{__sheet};
	return if $self->{row} > $sheet->{MaxRow};
	my $fields = $self->data->fields||[];
	my $N = scalar @$fields or return $self->error("No defined parameter: 'fields'");
	my %data;
	for my $col (0..$N-1) {
		if (my $cell = $sheet->{Cells}[$self->{row}][$col]) {
			my $val = $cell->Value;
			$self->decode($val);
			$data{$fields->[$col]} = $val;
		} else {
			$data{$fields->[$col]} = undef;
		}
	}
	$self->{row}++;
	return $self->create(\%data);
}

# 取得終了(ITERATORオブジェクト用)
sub finish_iter {
	my $self = shift;
	undef $self->{__sheet};
	return 1;
}

sub search { shift->croak("No supported handler method.") }
sub append { shift->croak("No supported handler method.") }
sub update { shift->croak("No supported handler method.") }

1;
__END__
# Copyright (C) 2000-2012 E-Shoppy Project developing team
# All rights reserved.
