# -*- mode: cperl; coding: utf-8-unix; indent-tabs-mode: t -*-
# $Id: $

package ESP::SMS::Plugin::gaimage;

use strict;
our $VERSION = '0.01';

use Cozy::Encode;

my $GA_PATH = '';
my $GA_FILE = 'ga.php'; # or 'ga.cgi/'
my $GA_ACCOUNT = '';

# このプラグインは、モバイル用Google Analyticsを表示するフィルター<% .gaimage %>を追加します。
sub import {
	no strict 'refs';
	*{'ESP::SMS::Plugin::DataFilter::filter_gaimage'} = \&filter_google_analytics_get_image_url;
}

# テンプレート(FOOTER.xhtmlなど)の記述例:
# <% IF GOOGLE_TRACKER -%>
# <% GOOGLE_TRACKER.gaimage %>
# <% END -%>

sub filter_google_analytics_get_image_url {
	my ($self, $account, $args) = @_;
	if ($GA_ACCOUNT) {
		$account = $GA_ACCOUNT;
	} elsif ($account && $account =~ /^UA-[0-9\-]+$/) {
		$account =~ s/^UA/MO/;
	} else {
		return '';
	}
	my $cmd = $self->{scope}->{param}->{cmd}||'';
	return '' unless $cmd eq 'xhtml';
	my $referer = defined $ENV{HTTP_REFERER} ? $ENV{HTTP_REFERER} : '';
	my $path = defined $ENV{REQUEST_URI} ? $ENV{REQUEST_URI} : '';
	$referer = '-' if $referer eq '';
	my $url = sprintf("%s%s?utmac=%s&utmn=%s&utmr=%s&utmp=%s&guid=ON",
					  $GA_PATH||$self->plugin->config->{CKE_PATH}||'/', $GA_FILE,
					  $account, int(rand(0x7fffffff)),
					  Cozy::Encode->uri_escape($referer),
					  Cozy::Encode->uri_escape($path));
	$url =~ s/&/&amp;/g if $url =~ /&/;
	return '<img src="'.$url.'" />';
}

1;
__END__
# Copyright (C) 2000-2012 E-Shoppy Project developing team
# All rights reserved.
